<template>
  <div>
    <button @click="removeItem">delete</button>
    <p>Id: {{item.id}}</p>
    <p>Name: {{item.name}}</p>
    <p>Description: {{item.description}}</p>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api';
import Item from '@/models/Item'
import ItemService from '@/services/ItemService';
import Items from '@/views/Items.vue';

const itemService = new ItemService();

export default defineComponent({
  name: 'ListItem',
  props: {
      item: {
          type: Object as () => Item
      },
  },
  setup(props, context) {
    
    function updateListItem(){
      context.emit("item-removed");
    }

    async function removeItem() {
      if(props.item){
        const response = await itemService.deleteItem(props.item.id);
        if(response){
          updateListItem();
        }
      }
    }

    return {
      removeItem,
      updateListItem
    }
  },
});
</script>
